/* os_module.h - 

   Copyright (c) 2010 Jukka Lehtosalo

   Alore is licensed under the terms of the MIT license.  See the file
   LICENSE.txt in the distribution.
*/

#ifndef OS_MODULE_H_INCL
#define OS_MODULE_H_INCL

#include "thread.h"
#include "util.h"


AValue ARemoveImpl(AThread *t, const AMixedCValue *frame);
AValue ARenameImpl(AThread *t, const AMixedCValue *frame);
AValue AMakeDirImpl(AThread *t, const AMixedCValue *frame);
AValue AChangeDirImpl(AThread *t, const AMixedCValue *frame);
AValue ACurrentDirImpl(AThread *t, const AMixedCValue *frame);
AValue ASleepImpl(AThread *t, const AMixedCValue *frame);
AValue ASystemImpl(AThread *t, const AMixedCValue *frame);
AValue AExistsImpl(AThread *t, const AMixedCValue *frame);
AValue AIsFileImpl(AThread *t, const AMixedCValue *frame);
AValue AIsDirImpl(AThread *t, const AMixedCValue *frame);
AValue AIsLinkImpl(AThread *t, const AMixedCValue *frame);
AValue AStatCreate(AThread *t, AValue *frame);
AValue AStatModificationTime(AThread *t, AValue *frame);
AValue AStatAccessTime(AThread *t, AValue *frame);
AValue AStatIsReadable(AThread *t, AValue *frame);
AValue AStatIsWritable(AThread *t, AValue *frame);
AValue AStatOwner(AThread *t, AValue *frame);
AValue AStatOwnerPerm(AThread *t, AValue *frame);
AValue AStatOtherPerm(AThread *t, AValue *frame);
AValue AListDirImpl(AThread *t, const AMixedCValue *frame);
AValue AWalkDirImpl(AThread *t, const AMixedCValue *frame);
AValue AGetEnvImpl(AThread *t, const AMixedCValue *frame);
AValue ASetEnvImpl(AThread *t, const AMixedCValue *frame);
AValue AListEnv(AThread *t, AValue *frame);
AValue AUnsetEnvImpl(AThread *t, const AMixedCValue *frame);
AValue ASetPermImpl(AThread *t, const AMixedCValue *frame);
AValue ASetModificationTime(AThread *t, AValue *frame);
AValue ASetAccessTime(AThread *t, AValue *frame);
AValue AOsUser(AThread *t, AValue *frame);


#endif
